# -*- coding: utf-8 -*-
"""
Created on Wed Jan 23 12:23:53 2019

@author: Domen
"""
#import time
#import urllib2
#import base64
#import json
#import math
#import os
#import datetime

from lxml import etree
import socket
import os

import threading
from generic_module import Module
 
class CommunicationModule(Module):
  def __init__(self, name, port, backlog, recv_buffer_size, root_path):
    Module.__init__(self, name, root_path)
    self.port = port
    self.backlog = backlog
    self.recv_buffer_size = recv_buffer_size
    self.parser = etree.XMLParser(remove_blank_text=True)
    
    self.num_of_clients = 0
    self.clients_lock = threading.Lock()
    
    self.reset_i = False
  
  def are_we_resetting(self):
    return self.reset_i
  
  def set_end(self):
    self.end = True
    #this will initiate shutdown procedure; a bit hacky, but this is how we do thing around here
    s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)  
    s.connect(("127.0.0.1", self.port))
    try:
      s.close()
    except Exception:
      pass
  
  def form_message(self, info, typ):
    top_element = etree.Element("i-message", type = typ)
    for key, val in info.iteritems():
      tag = etree.Element(key)
      tag.text = val
      top_element.append(tag)
    return etree.tostring(top_element, pretty_print=False)    
  
  def clientthread(self, conn):
    if self.end:
      return
    with self.clients_lock:
      self.num_of_clients+=1
    line = ""
    timeout = 5
    cnt = 0
    starting_tag_id = -1
    closing_tag_id = -1
    while cnt < timeout and (starting_tag_id < 0 or closing_tag_id < 0):
      line = line + conn.recv(self.recv_buffer_size)
      starting_tag_id = line.find("<i-message ")
      closing_tag_id = line.find("</i-message>")
      cnt+=1
    if starting_tag_id < 0 or closing_tag_id < 0:
      conn.send(self.form_message({"status":"ERR"}, "comm_response"))
      conn.close()
      with self.clients_lock:
        self.num_of_clients-=1
      return
    original_xml = None
    try:
      original_xml = etree.fromstring(line, self.parser)  
    except Exception:
      self.log(line)
      conn.send(self.form_message({"status":"ERR"}, "comm_response"))
      conn.close()
      with self.clients_lock:
        self.num_of_clients-=1
      return
    if original_xml.attrib["type"] == "conf_request":
      if os.path.exists("conf/conf.xml"):
        fd = open("conf/conf.xml", "r")
        conf_xml = None
        try:
          conf_xml = etree.parse(fd)
          msg = self.form_message({"status":"OK"}, "comm_response")
          msg_node = etree.fromstring(msg)
          msg_node.append(conf_xml.getroot())
          conn.send(etree.tostring(msg_node, pretty_print=False))
        except Exception, ex:
          self.log(str(ex))
          conn.send(self.form_message({"status":"ERR"}, "comm_response"))
          #conn.close()
        fd.close()
      else:
        self.log(str("Conf file doesn't exist."))
        conn.send(self.form_message({"status":"ERR"}, "comm_response"))
      #conn.close()
    if original_xml.attrib["type"] == "conf":
      fd = open("conf/conf.xml", "w")
      fd.write(etree.tostring(original_xml.find("conf"), pretty_print=True))
      fd.close()
      self.reset_i = True
    conn.close()
    with self.clients_lock:
      self.num_of_clients-=1
      
  def run(self):
    self.alive = True
    self.end = False
    try:
      self.sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM) 
      self.sock.bind(('', self.port))
      self.sock.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
      self.sock.listen(self.backlog)
    except Exception, ex:
      self.log(str(ex))
      self.alive = False
      return
    try:
      while  True:
        conn, addr = self.sock.accept()
        if self.end:
          while True:
            with self.clients_lock:
              if self.num_of_clients == 0:
                try:
                  conn.close()
                except Exception:
                  pass
                self.sock.close()
                self.alive = False
                return
            self.zzzzz(0.5)
        threading.Thread(target=self.clientthread, args=(conn,)).start()
    except Exception, ex:
      self.log(str(ex))
      self.sock.close()
    self.alive = False

        

      
      
    
    #i_message = original_xml 
  
    