import os
import datetime
import time

class Module():
  def __init__(self, name, root_path):
    self.name = name
    self.root_path = root_path
    
    self.end = False
    self.alive = True
    
    self.downstream_modules_dict = dict()
    self.sname = ""
    self.sites_path = ""
   
  def set_sites_path(self, sites_path):
    self.sites_path = sites_path
        
  def set_end(self):
    self.end = True
  
  #methods that "return True" are somwhat special and should be reimplemented in certain modules
  def add_downstream_module(self, module):
    self.downstream_modules_dict[module.get_name()] = module
    
  def set_site_name(self, sname):
    if sname != "":
      self.sname = sname
  
  #TODO: generalize this into get_temperature and get_voltage  
  def set_ctu_data(self, fw_version, voltage):
    return True
  
  def set_hist_data(self, fw_version, voltage):
    return True
    
  def get_name(self):
    return self.name

  #TODO: generalize this into "add_data" or something; this is a method for forwarding data to downstream modules
  def add_vehicle(self, sub_vehicle, module_name):
    return True  
  
  def tell_offset(self, module_name, offsets_dict):
    return True  
  
  #TODO: alarm module specific; does this need to be here?
  def register_alarm(self, module_name):
    return True
  
  #for now, only used in output module; this is used to prevent modules to send data to output modules if there is no listeners
  def is_doing_something(self):
    return True  
  
  
  def is_alive(self):
    return self.alive
  
  def log(self, msg): 
    if not os.path.exists("log"):
      os.mkdir("log/")
    fd = open("log/" + (datetime.datetime.today().strftime('%Y-%m-%d')) + "_" + str(self.name) + ".log", "a")
    fd.write(datetime.datetime.today().strftime('%Y-%m-%d %H:%M:%S') + ": " + msg + "\n")
    fd.close()
    
  def zzzzz(self, seconds):
    cnt = 0
    while cnt < seconds * 2:
      if self.end:
        self.alive = False
        return
      try:
        time.sleep(0.5)
      except Exception:
        continue
      cnt+=1
    return
    
  def run(self):
    return True